var
	VILLAGE_NAMES = list("Marryatville", "Sleepydale", "Smallton", "Farmeshrop", "Cowhaven", "Sheepvale", "Berry-on-hill", "Rainside", "Hillfell", "Stonybrook", "Noah Vale")
	TOWN_NAMES = list("Bloomsberg", "Cartella", "Shawside", "Pennyforth", "Whyalla", "Goose Hill", "Bigshire", "Lovesdale", "Mildura", "Quakenville")
	CITY_NAMES = list("Hugedon", "Workston", "Old York", "Dollardrop", "Rhodesville", "Ankh", "Morpork", "Prenville", "Hewayside", "Hazedale")
city
	var
		name
		list
			city/links

		list
			media/companies = list()
			demand = list()
			numsold = list()

		population
		turf/location

	New()
		switch(rand(1,3))
			if(1) //Village
				population = rand(10,50)
				name = pick(VILLAGE_NAMES)
				companies+=new /media(src)

			if(2) //Town
				population = rand(100, 500)
				name = pick(TOWN_NAMES)
				companies+=new /media(src)
				companies+=new /media(src)

			if(3) //City
				population = rand(1000, 5000)
				name = pick(CITY_NAMES)
				companies+=new /media(src)
				companies+=new /media(src)
				companies+=new /media(src)

		for(var/media/m in companies) demand["\ref[m]"] = rand(0, 100)

	proc
		addLink(city/c)
			if(!links) links = list()
			links+=c

		sim_step()
			for(var/media/m in companies)
				var/numbought = demand["\ref[m]"]
				numbought+=rand(-5,5)
				numbought=min(max(0, numbought), 100)
				numbought/=100
				numbought*=population
				numbought=round(numbought)

				numbought = min(numbought, m.temp_num_papers)
				m.money+=numbought*m.price
				m.temp_num_papers-=numbought
				numsold["\ref[m]"] = numbought

			var/list/score = list()
			for(var/media/m in companies) score["\ref[m]"] = 50+rand(-5, 5)

			for(var/media/m in companies)
				var/s = score["\ref[m]"]
				if(m.price<1.2)	s+=(1.2-m.price)*100
				if(m.price>1.8) s+=(1.8-m.price)*100
				for(var/media/m2 in companies)
					if(m.price<m2.price) s+=5
					if(m.price>m2.price) s-=5
				score["\ref[m]"] = s

			for(var/media/m in companies)
				var/s = score["\ref[m]"] - 50
				var/mod = 1
				if(s>0)
					mod = 1 - (demand["\ref[m]"]/100)
				else
					mod = demand["\ref[m]"]/100

				demand["\ref[m]"] += s*mod
				if(demand["\ref[m]"]>100) demand["\ref[m]"]=100
				if(demand["\ref[m]"]<0) demand["\ref[m]"]=0